# Desc: Device definitions for Activemedia robots.
# Author: Andrew Howard, Richard Vaughan
# Date: 10 Jun 2002
# CVS: $Id: pioneer.inc,v 1.15 2004/12/09 01:34:44 rtv Exp $


# The Pioneer2DX sonar array
define p2dx_sonar ranger
(
  scount 18

  # define the pose of each transducer [xpos ypos heading]
  spose[0]  [ 0.24  0.15 0 ]
  spose[1]  [ 0.25  0.12 0 ]
  spose[2]  [ 0.25  0.09 0 ]
  spose[3]  [ 0.25  0.06 0 ]
  spose[4]  [ 0.25  0.03 0 ]
  spose[5]  [ 0.25  0.00 0 ]
  spose[6]  [ 0.25 -0.03 0 ]
  spose[7]  [ 0.25 -0.06 0 ]
  spose[8]  [ 0.25 -0.09 0 ]
  spose[9]  [ 0.25 -0.12 0 ]
  spose[10] [ 0.24 -0.15 0 ]
  spose[11] [ 0.15  0.18 90]
  spose[12] [-0.15  0.18 90]
  spose[13] [ 0.15 -0.18 -90]
  spose[14] [-0.15 -0.18 -90]
  spose[15] [-0.25  0.12 180]
  spose[16] [-0.25  0.00 180]
  spose[17] [-0.25 -0.12 180]
		
  # define the field of view of each transducer [range_min range_max view_angle]
  sview[0]  [ 0.04 0.5 1 ]
  sview[1]  [ 0.20 1.0 1 ]
  sview[2]  [ 0.04 0.5 1 ]
  sview[3]  [ 0.20 1.0 1 ]
  sview[4]  [ 0.04 0.5 1 ]
  sview[5]  [ 0.20 1.0 1 ]
  sview[6]  [ 0.04 0.5 1 ]
  sview[7]  [ 0.20 1.0 1 ]
  sview[8]  [ 0.04 0.5 1 ]
  sview[9]  [ 0.20 1.0 1 ]
  sview[10] [ 0.04 0.5 1 ]
  sview[11] [ 0.04 0.5 1 ]
  sview[12] [ 0.04 0.5 1 ]
  sview[13] [ 0.04 0.5 1 ]
  sview[14] [ 0.04 0.5 1 ]
  sview[15] [ 0.04 0.5 1 ]
  sview[16] [ 0.04 0.5 1 ]
  sview[17] [ 0.04 0.5 1 ]

  # define the size of each transducer [xsize ysize] in meters
  ssize [0.01 0.01]
)

# a Pioneer 2 or 3 in standard configuration
define pioneer2dx position
(
  # actual size
  size [0.50 0.36]

  # the pioneer's center of rotation is offset from its center of area
  origin [0.0 0.0 0]

  # draw a nose on the robot so we can see which way it points
  gui_nose 1
  gui_boundary 0	

  # estimated mass in KG
  mass 15.0 
	
  # this polygon approximates the shape of a pioneer
  polygons 1
  polygon[0].points 6
  polygon[0].point[0] [  0.25  0.15 ]
  polygon[0].point[1] [  0.23  0.18 ]
  polygon[0].point[2] [ -0.25  0.18 ]
  polygon[0].point[3] [ -0.25 -0.18 ]
  polygon[0].point[4] [  0.23 -0.18 ]
  polygon[0].point[5] [  0.25 -0.15 ]
  polygon[0].filled 1

  # differential steering model
  drive "diff"

  # use the sonar array defined above
  p2dx_sonar()  
) 
