#include "includes.h"

int init_client (PlayerClient &client) {

    logI ("init_client: connecting to client (host = %s, port = %d).\n", PLAYER_HOST, PLAYER_PORT);

    if (client.Connect(PLAYER_HOST, PLAYER_PORT) != 0) {
      logE("init_client: could not connect to client!\n");
      return -1;
    }

    logD ("init_client: setting data delivery mode to PLAYER_DATAMODE_PULL_NEW\n");

    if (client.SetDataMode(PLAYER_DATAMODE_PULL_NEW) != 0) {
      logE("init_client: could set data delivery mode!\n");
      return -1;
    }

    return 0;
}

void destroy_client (PlayerClient &client) {
    logD("destroy_client: Destroying client instance...\n");
    client.Disconnect();
    client.~PlayerClient();
}
	    
