#include "includes.h"

int init_laser (PlayerClient &client, LaserProxy &laser) {
    
    logI ("init_laser: Subscribing laser interface...\n");
    if (laser.ChangeAccess('r') != 0) {
         logF("init_laser: Could not subscribe the laser device!\n");
	 return -1;
    }
/*
    check_laser_config(laser);

    logI ("init_laser: Setting laser configuration...\n");
    logD ("init_laser: Min_angle =   0 degrees ( 0 radians)\n");
    logD ("init_laser: Max_angle = 180 degrees (PI radians)\n");
    logD ("init_laser: Resolution = %d (in 0.01 degree increments)\n", (int) (STEP_LASER_ANGLE * 100));
    logD ("init_laser: Range resolution = 1 (mm)\n");
    logD ("init_laser: Intensity = 0 (disable reflection intensity)\n");
    
    if (laser.Configure (deg2rad(-90), deg2rad(90), 
		(unsigned int) (STEP_LASER_ANGLE * 100), 1, 0 ) != 0) {
	logE ("init_laser: Could not set scanner configuration!\n");
	return -1;
    }
*/
    return 0;
}

void destroy_laser (LaserProxy &laser) {
    logD ("destroy_laser: Destroying laser interface...\n");
    laser.Close();
    laser.~LaserProxy();
}

 
void check_laser_config (LaserProxy &laser) {
    logD ("check_laser_config: reading laser configuration...\n");
	
    if (laser.GetConfigure() != 0) {
	logW("check_laser_config: Could not check the laser configuration!\n");
	return;
    }

    logD ("init_laser: Min_angle = %lf degrees (%lf radians)\n", rad2deg(laser.min_angle), laser.min_angle);
    logD ("init_laser: Max_angle = %lf degrees (%lf radians)\n", rad2deg(laser.max_angle), laser.max_angle);
    logD ("init_laser: Scan resolution = %lf (in 0.01 degree increments)\n", laser.scan_res);
    logD ("init_laser: Range resolution = %lf (mm)\n", laser.range_res);
    
}

/*
int allocate_mem_Scan2D (Scan2D_t *scan) {
    int size = 180 / STEP_LASER_ANGLE + 1;
    
    scan->point = (vertex_t *) malloc (size * sizeof(vertex_t));
    
    if (scan->point == NULL) {
	logF("allocate_mem_Scan2D: could not allocate memory!\n");
	return -1;
    }
    
    return 0;
}

int allocate_mem_Scan3D (Scan3D_t *scan) {
    int size = (MAX_TILT_ANGLE - MIN_TILT_ANGLE) / STEP_TILT_ANGLE + 1;

    scan->line = (Scan2D_t *) malloc (size * sizeof(Scan2D_t));

    if (scan->line == NULL) {
        logF("allocate_mem_Scan3D: could not allocate memory!\n");
        return -1;
    }

    return 0;
}

void free_mem_Scan2D (Scan2D_t *scan) {
    if (scan->point != NULL) 
        free (scan->point);
}

void free_mem_Scan3D (Scan3D_t *scan) {
    if (scan->line != NULL) {
//	for(...) free_mem_Scan2D();
        free (scan->line);
    }
}

void get_Scan2D (PlayerClient &client, LaserProxy &laser, TruthProxy &truth, double ptz_angle, Scan2D_t *scan) {    
    int i;
    double ray, deg;
    
    allocate_mem_Scan2D(scan);

    //check the current position, angles, read laser data
    get_truth_pos(client, truth, &scan->base.x, &scan->base.y, &scan->base.z, &scan->roll, &scan->pitch, &scan->yaw);

    scan->pitch = deg2rad(ptz_angle);
    scan->base.z += (double) LASER_TRUTH_Z_OFFSET / 1000.0;
    
    logI ("base.x = %lf, base.y = %lf, base.z = %lf\n", scan->base.x, scan->base.y, scan->base.z);
    for (i = 0; i <= 180 / STEP_LASER_ANGLE; i++) {
	ray = laser[180 / STEP_LASER_ANGLE - i];
	deg = -90 + i * STEP_LASER_ANGLE;
	
        scan->point[i].x = scan->base.x + 
		ray * cos (scan->yaw - deg2rad(deg)) * ((cos (scan->pitch) - 1) * cos(deg2rad(deg)) + 1);

	scan->point[i].y = scan->base.y + 
		ray * sin (deg2rad(deg) - scan->yaw) * ((cos (-scan->pitch) - 1) * cos(deg2rad(deg)) + 1);

	scan->point[i].z = scan->base.z + 
		ray * sin (scan->pitch) * sin (deg2rad((double)i*STEP_LASER_ANGLE));
//	logI ("Ray length = %lf, Degrees: %lf, x = %lf, y = %lf, z = %lf, wplyw = %lf\n", ray, 
//			deg, scan->point[i].x, scan->point[i].y, scan->point[i].z, cos(deg2rad(deg)));

    }
}

int get_Scan3D (PlayerClient &client, LaserProxy &laser, TruthProxy &truth, PtzProxy &ptz, Scan3D_t *scan) {
    double ptz_angle;
    int i;

    allocate_mem_Scan3D (scan);

    if (wait_for_tilt(client, ptz, MIN_TILT_ANGLE) != 0) {
        logE("get_Scan3D: Tilt value %lf could not be reached!\n", MIN_TILT_ANGLE);
	return -1;
    }
    
    for (i=0, ptz_angle = MIN_TILT_ANGLE; ptz_angle <= MAX_TILT_ANGLE; ptz_angle += STEP_TILT_ANGLE, i++) {
        if (wait_for_tilt(client, ptz, ptz_angle) != 0) {
            logE("get_Scan3D: Tilt value %lf could not be reached!\n", ptz_angle);
            return -1;
        } 
	get_Scan2D (client, laser, truth, ptz_angle, &scan->line[i]);
    }
}
*/
