#include "includes.h"

char *log_types [] = {"INFO   ", "FATAL  ", "ERROR  ", "WARNING", "DEBUG  ", "S-DEBUG"};

void logSD (char *msg, ...) { va_list args; va_start(args, msg); loggit (5, msg, args); }
void logD (char *msg, ...) { va_list args; va_start(args, msg); loggit (4, msg, args); }
void logW (char *msg, ...) { va_list args; va_start(args, msg); loggit (3, msg, args); }
void logE (char *msg, ...) { va_list args; va_start(args, msg); loggit (2, msg, args); }
void logF (char *msg, ...) { va_list args; va_start(args, msg); loggit (1, msg, args); }
void logI (char *msg, ...) { va_list args; va_start(args, msg); loggit (0, msg, args); }
    
void loggit (int level, char *msg, va_list args) {
    time_t time_ptr;
    FILE *file_ptr;
    char *cur_time;

    if (!WRITE_LOGS_TO_STDOUT && !WRITE_LOGS_TO_FILE) {return;} //do not log at all
    
    time(&time_ptr);
    cur_time = asctime(localtime(&time_ptr));	//human readable date
    cur_time[strlen(cur_time) - 1] = '\0';	//remove newline character

    if (WRITE_LOGS_TO_FILE && LOG_LEVEL_FILE >= level) {
	file_ptr = fopen (LOG_FILE, "a+");
    	if (file_ptr == NULL) {
		printf ("Warning: could not open log file for writing!!\n");
		return;
    	}
    	fseek (file_ptr, 0, SEEK_END);
    
	
    	fprintf (file_ptr, "%s %s  ", log_types[level], cur_time); 
    	vfprintf (file_ptr, msg, args);
    
	fclose (file_ptr);
    }

    if (WRITE_LOGS_TO_STDOUT && LOG_LEVEL_STDOUT >= level) {
	printf ("%s %s  ", log_types[level], cur_time); 
	vprintf (msg, args);
    }
}

void sleep_ms (unsigned int ms) {
    struct timespec t, v;

    t.tv_sec = ms / 1000;
    t.tv_nsec = (ms - 1000 * t.tv_sec) * 1000000;

    //logD ("Sleep_ms: Sleeping for %d seconds and %ld nanoseconds\n", t.tv_sec, t.tv_nsec);
    nanosleep(&t, &v);
}

int ms_passed (struct timeval start, struct timeval stop) {
    return (int) (1000 * (double)(stop.tv_sec  - start.tv_sec) +
	         0.001 * (double)(stop.tv_usec - start.tv_usec));
}
