#include "includes.h"

int init_position (PositionProxy &pos) {

    logI ("init_position: Subscribing position interface...\n");
    if (pos.ChangeAccess('r') != 0)
    {
      logF ("init_position: could not subscribe position interface!\n");
      return -1;
    }

    return 0;

}

void destroy_position (PositionProxy &pos) {
    logD ("destroy_position: Destroying position interface...\n");
    pos.Close();
    pos.~PositionProxy();	    
}

void get_position (PlayerClient &client, PositionProxy &position, double *x, double *y, double *yaw) {
    client.Read();
    *x = position.xpos;
    *y = position.ypos;
    *yaw = position.theta;
}
