#include "includes.h"


int main () {
    PlayerClient client(NULL);
    PtzProxy ptz(&client, 0);
    LaserProxy laser(&client, 0);
    //TruthProxy truth(&client, 0);
    PositionProxy pos(&client, 3);
    char c;
    Scene scene;

    int i;
   
    if ((init_client(client)) != 0)        
    	{ logF("main: client initialization failed!\n");             return -1;}
    if ((init_ptz(ptz)) !=0)               
    	{ logF("main: PTZ initialization failed!\n");                return -1;}
    if ((init_laser(client, laser)) != 0)  
    	{ logF("main: laser initialization failed!\n");              return -1;}
  //  if ((init_truth(truth)) != 0)          
  //  	{ logF("main: truth interface initialization failed!\n");    return -1;}
    if ((init_position(pos)) != 0)         
    	{ logF("main: position interface initialization failed!\n"); return -1;}

    logI ("Main: Starting simulation...\n");
    
    client.Read();

	wait_for_tilt(client, ptz, 1);
	//wait_for_tilt(client, ptz, 0);
	
    while (1) {
        printf("\nEnter - get scan. Anything else and enter - exit program.\nYour command: ");
	c = (char) getchar();

	if (c != '\n')
	    break;
	
	wait_for_tilt(client, ptz, 0);
	
	//scene.AddScan(client, laser, truth, ptz);
	scene.AddScan(client, laser, pos, ptz);
    }
  
    scene.WritePolygons ("scena.m");
    scene.WriteCones ("scena.mm");

    logI ("Main: Stopping simulation...\n");
    
    destroy_position(pos);
    //destroy_truth(truth);
    destroy_laser(laser);
    destroy_ptz(ptz);
    destroy_client(client);
    
    return 0;
}
