#include "includes.h"

int init_truth (TruthProxy &truth) {

    logI ("init_truth: Subscribing truth interface...\n");
    if (truth.ChangeAccess('r') != 0)
    {
      logF ("init_truth: could not subscribe truth interface!\n");
      return -1;
    }

    return 0;

}

void destroy_truth (TruthProxy &truth) {
    logD ("destroy_truth: Destroying truth interface...\n");
    truth.Close();
    truth.~TruthProxy();
}

void get_truth_pos (PlayerClient &client, TruthProxy &truth, 
		double *x, double *y, double *z, double *roll, double *pitch, double *yaw) {
    client.Read();
    truth.GetPose(x, y, z, roll, pitch, yaw);
}
